--Declare everything
local pingFrame = CreateFrame("Frame", "PFrame", UIParent);
local pingLocal = pingFrame:CreateFontString("PLocal", "OVERLAY");
local pingWorld = pingFrame:CreateFontString("PWorld", "OVERLAY");
local gameFPS = pingFrame:CreateFontString("GFPS", "OVERLAY");
local LSM = LibStub("LibSharedMedia-3.0");
local updateInterval = 0;

--Global variable
setColor = nil;

--Set frame moveable
pingFrame:SetMovable(true)
pingFrame:EnableMouse(true)
pingFrame:RegisterForDrag("LeftButton")
pingFrame:SetScript("OnDragStart", pingFrame.StartMoving)
pingFrame:SetScript("OnDragStop", pingFrame.StopMovingOrSizing)
pingFrame:SetPoint("TOP", UIParent, "CENTER", 0, 0)
pingFrame:SetSize(160, 60)

--Register addon loaded
pingFrame:RegisterEvent("ADDON_LOADED");
--Register player logout
pingFrame:RegisterEvent("PLAYER_LOGOUT");

function pingFrame:OnEvent(event, arg1)
	if event == "ADDON_LOADED" and arg1 == "LagMonitor" then
		if LagMonitorDB == nil then
			LagMonitorDB = true;
			setColor = true;
		else
		if LagMonitorDB == true then
			setColor = true;
		else
		if LagMonitorDB == false then
			setColor = false;
		elseif event == "PLAYER_LOGOUT" then
			LagMonitorDB = setColor;
			end
		end
	end
		
		--Declare font being used
		local myFont = LSM:Fetch("font","Font2");
	
		if (DEFAULT_CHAT_FRAME) then
			DEFAULT_CHAT_FRAME:AddMessage('LagMonitor v1.4: AddOn Loaded.');
		end;
	
		--Assign Local ping fonts
		pingLocal:SetFont(myFont,17,"OUTLINE");
		pingLocal:SetPoint("RIGHT", pingFrame, "RIGHT", -2, 15);
	
		--Assign World ping fonts
		pingWorld:SetFont(myFont,17,"OUTLINE");
		pingWorld:SetPoint("RIGHT", pingFrame, "RIGHT", -2, -1);
	
		
		--Assign Game fps fonts
		gameFPS:SetFont(myFont,17,"OUTLINE");
		gameFPS:SetPoint("RIGHT", pingFrame, "RIGHT", -2, -17);
		
--PASTE BUTTON HERE
		
		local pLocal = pingFrame:CreateFontString("PLocal", "OVERLAY");
		local pWorld = pingFrame:CreateFontString("PWorld", "OVERLAY");
		local gFPS = pingFrame:CreateFontString("GFPS", "OVERLAY");
		
				--Assign Game fps fonts
		pLocal:SetFont(myFont,17,"OUTLINE");
		pLocal:SetPoint("LEFT", pingFrame, "LEFT", 5, 15);
		
				--Assign Game fps fonts
		pWorld:SetFont(myFont,17,"OUTLINE");
		pWorld:SetPoint("LEFT", pingFrame, "LEFT", 5, -1);
		
				--Assign Game fps fonts
		gFPS:SetFont(myFont,17,"OUTLINE");
		gFPS:SetPoint("LEFT", pingFrame, "LEFT", 5, -17);
		
		pLocal:SetTextColor(1, 1, 0, 1);
		pLocal:SetFormattedText("Home(ms):");
		
		pWorld:SetTextColor(1, 1, 0, 1);
		pWorld:SetFormattedText("World(ms):");
		
		gFPS:SetTextColor(1, 1, 0, 1);
		gFPS:SetFormattedText("FPS:");
		
		local pingFrameBG = {
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",  
  
		edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
  
		tile = true,
		--"Interface\\DialogFrame\\UI-DialogBox-Border"
  
		tileSize = 32,
		edgeSize = 20,
		insets = {
		left = 5,
		right = 5,
		top = 5,
		bottom = 5
			}
		}
		pingFrame:SetBackdrop(pingFrameBG)
	end
end

pingFrame:SetScript("OnEvent", pingFrame.OnEvent);

local function onUpdate(self, elapsed)
	updateInterval = updateInterval + elapsed
		if updateInterval >= 2 then
			
			--Declare Variables
			local up, down, home, world = GetNetStats();
			local fps = GetFramerate();
	
			--Display Local ping
			if setColor == true then
				if home < 250 then
				pingLocal:SetTextColor(0, 1, 0, 1);
				end
				if ((home >= 250) and (home < 400)) then
				pingLocal:SetTextColor(1, 1, 0, 1);
				end
				if home >= 400 then
				pingLocal:SetTextColor(1, 0, 0, 1);
				end
			end
			if setColor == false then
				pingLocal:SetTextColor(1, 1, 0, 1);
			end
			pingLocal:SetFormattedText(home);
	
			--Display World ping
			if setColor == true then
				if world < 250 then
				pingWorld:SetTextColor(0, 1, 0, 1);
				end
				if ((world >= 250) and (world < 400)) then
				pingWorld:SetTextColor(1, 1, 0, 1);
				end
				if world >= 400 then
				pingWorld:SetTextColor(1, 0, 0, 1);
				end
			end
			if setColor == false then
				pingWorld:SetTextColor(1, 1, 0, 1);
			end
			pingWorld:SetFormattedText(world);
	
			--Display Game FPS
			if setColor == true then
				if floor(fps) <= 30 then
				gameFPS:SetTextColor(1, 0, 0, 1);
				end
				if ((floor(fps) > 30) and (floor(fps) <= 60)) then
				gameFPS:SetTextColor(1, 1, 0, 1);
				end
				if floor(fps) > 60 then
				gameFPS:SetTextColor(0, 1, 0, 1);
				end
			end
			if setColor == false then
				gameFPS:SetTextColor(1, 1, 0, 1);
			end
			gameFPS:SetFormattedText(floor(fps));
			
		updateInterval = 0;
		end
end

pingFrame:SetScript("OnUpdate", onUpdate);